from pyRepetUnit.commons.IHmmOutputProcessing import IHmmOutputProcessing
import pyRepetUnit.commons.utils.HmmOutputUtils
from pyRepet.util.file.FileUtils import *

class HmmOutputProcessing (IHmmOutputProcessing):
    
    """
    Concrete implementation for common methods
    """
    
    #--------------------------------------------------------------------------
    def __init__(self):
        self.hmmOutputUtils = pyRepetUnit.commons.utils.HmmOutputUtils.HmmOutputUtils()
    
    #--------------------------------------------------------------------------
    
    def writeHmmOutputToAlignFile( self,hmmOutput, fout ):   
        """
        write an align file from hmmOutput object
        """    
        self.hmmOutputUtils.writeHmmOutputToAlignFile(hmmOutput, fout)
        
    
    #--------------------------------------------------------------------------
    
    def readHmmOutputsAndWriteAlignFile( self, inputFile, outputFile ):
        """
        read an output file from hmm profiles search program and write the corresponding .align file
        """  
        fileUtils = FileUtils() 
        if not fileUtils.isRessourceExists(inputFile):
            print "Warning your input file " + inputFile + " does not exist!\n"
            return
        file2parse = open( inputFile )
        pfamOutput = pyRepetUnit.hmmer.hmmOutput.HmmpfamOutput.HmmpfamOutput()
        if outputFile == "":
            print "Warning have to specify an output name file!\n"
            return
        fout = open(outputFile, "w")        
        while pfamOutput != None:      
            pfamOutput = self.readHmmOutput(file2parse)             
            if pfamOutput != None:  
                self.writeHmmOutputToAlignFile(pfamOutput, fout)
        fout.close()
        file2parse.close() 
        
    
    
    #--------------------------------------------------------------------------
    
if __name__ == "__main__":                 
    main()        